<?php
/**
 * 订单查询（协议支付）
 * Company: www.baofu.com
 * @author dasheng(大圣)
 * @date 2018年3月15日
 */
require_once '../Init/init.php';

Log::EchoFormat("==========================");
Log::EchoFormat("订单查询 测试实例");
Log::EchoFormat("==========================");

$DateArry = array();
$DateArry["send_time"]=Tools::getTime();
$DateArry["msg_id"]="TISN".Tools::getTransid().Tools::getRand4();//报文流水号
$DateArry["version"]=$GLOBALS["Version"];
$DateArry["terminal_id"]= $GLOBALS["Terminal_Id"];
$DateArry["txn_type"]= "07";//交易类型
$DateArry["member_id"]=$GLOBALS["Member_Id"];
$DateArry["orig_trans_id"]="TID16879351443055";//交易时的trans_id
$DateArry["orig_trade_date"]= Tools::getTime();//

Log::EchoFormat("报文流水号:".$DateArry["msg_id"]);
$SignVStr =  Tools::SortAndOutString($DateArry);//签名字段格式化
Log::EchoFormat("SHA-1摘要明文字串：".$SignVStr);
$SHA1Sign = SHA1Util::Sha1AndHex(urldecode($SignVStr));//签名(注意此处urldecode方法主要是去除send_time中间的空格和符号的自动自urlencode)
Log::EchoFormat("SHA-1摘要结果：".$SHA1Sign);

$Sign = SignatureUtils::Sign($SHA1Sign, $GLOBALS["PFX_FILE_PATH"],$GLOBALS["KEY_PWD"]);
Log::EchoFormat("RSA签名结果：".$Sign);
$DateArry["signature"]=$Sign;//签名域

$PostString  =  HttpClient::Post($DateArry, $GLOBALS["POST_URL"]);
Log::EchoFormat("请求返回:".$PostString);

IF(empty($PostString)){
    throw new Exception("返回异常！");
}
parse_str($PostString,$ReturnData);//参数解析

if(!array_key_exists("signature",$ReturnData)){
    throw new Exception("缺少验签参数！");
}
$RSign=$ReturnData["signature"];//存储返回签名做后续验签使用。
$RSignArray = Tools::array_remove($ReturnData, "signature");//需要删除签名字段

$RSignVStr =Tools::SortAndOutString($RSignArray);
Log::EchoFormat("返回SHA-1摘要字串：".urldecode($RSignVStr));

$RSignature = SHA1Util::Sha1AndHex(urldecode($RSignVStr));//签名(注意此处urldecode方法主要是去除send_time中间的空格和符号的自动自urlencode)
Log::EchoFormat("返回SHA-1摘要结果：".$RSignature);

if(SignatureUtils::VerifySign($RSignature,$GLOBALS["CER_FILE_PATH"],$RSign)){
    Log::EchoFormat("验签:Yes");//验签成功
}  else {
    throw new Exception("验签失败！");
}

if(!array_key_exists("resp_code",$RSignArray)){
    throw new Exception("缺少resp_code参数！");
}

if($RSignArray["resp_code"] == "S"){
    Log::EchoFormat("支付成功！[trans_id:".$RSignArray["trans_id"]."]");
}else if($RSignArray["resp_code"] == "I"){	
    Log::EchoFormat("处理中！");
}else if($RSignArray["resp_code"] =="F"){
    Log::EchoFormat("失败！");
}else{
    throw new Exception("反回异常！");//异常不得做为订单状态。
}