<?php
/**
 * 预绑卡（协议支付）
 * Company: www.baofu.com
 * @author dasheng(大圣)
 * @date 2018年3月15日
 */
require_once '../Init/init.php';

Log::EchoFormat("==========================");
Log::EchoFormat("预绑卡 测试实例");
Log::EchoFormat("==========================");
$AesKey = "4f66405c4f66405c";//商户自定义（可随机生成  商户自定义(AES key长度为=16位)）
$dgtl_envlp = "01|".$AesKey;//使用接收方的公钥加密后的对称密钥，并做Base64转码，明文01|对称密钥，01代表AES[密码商户自定义]

Log::EchoFormat("密码dgtl_envlp：".$dgtl_envlp);
$dgtl_envlp = RSAUtil::encryptByCERFile($dgtl_envlp, $GLOBALS["CER_FILE_PATH"]);//公钥加密	
Log::EchoFormat("RSA数字信封：".$dgtl_envlp);
$Cardinfo = "6222020111122220000|张宝|340101198108119852|18689262776||";//账户信息[银行卡号|持卡人姓名|证件号|手机号|银行卡安全码|银行卡有效期]
Log::EchoFormat("卡信息：".$Cardinfo.",长度：".strlen($Cardinfo));		
$CardinfoAES = AESUtil::AesEncrypt(base64_encode($Cardinfo), $AesKey);//先BASE64后进行AES加密

Log::EchoFormat("AES结果:".$Cardinfo);
$DateArry = array();
$DateArry["send_time"]=Tools::getTime();
$DateArry["msg_id"]="TISN".Tools::getTransid().Tools::getRand4();//报文流水号
$DateArry["version"]=$GLOBALS["Version"];
$DateArry["terminal_id"]= $GLOBALS["Terminal_Id"];
$DateArry["txn_type"]= "01";//交易类型
$DateArry["member_id"]=$GLOBALS["Member_Id"];
$DateArry["dgtl_envlp"]=$dgtl_envlp;
$DateArry["user_id"]= "";//用户在商户平台唯一ID
$DateArry["card_type"]="101";//卡类型  101	借记卡，102 信用卡
$DateArry["id_card_type"]= "01";//证件类型
$DateArry["acc_info"]=$CardinfoAES;

Log::EchoFormat("报文流水号:".$DateArry["msg_id"]);
$SignVStr =  Tools::SortAndOutString($DateArry);//签名字段格式化
Log::EchoFormat("SHA-1摘要明文字串：".$SignVStr);
$SHA1Sign = SHA1Util::Sha1AndHex(urldecode($SignVStr));//签名(注意此处urldecode方法主要是去除send_time中间的空格和符号的自动自urlencode)
Log::EchoFormat("SHA-1摘要结果：".$SHA1Sign);

$Sign = SignatureUtils::Sign($SHA1Sign, $GLOBALS["PFX_FILE_PATH"],$GLOBALS["KEY_PWD"]);
Log::EchoFormat("RSA签名结果：".$Sign);
$DateArry["signature"]=$Sign;//签名域

$PostString  =  HttpClient::Post($DateArry, $GLOBALS["POST_URL"]);
Log::EchoFormat("请求返回:".$PostString);

IF(empty($PostString)){
    throw new Exception("返回异常！");
}
parse_str($PostString,$ReturnData);//参数解析

if(!array_key_exists("signature",$ReturnData)){
    throw new Exception("缺少验签参数！");
}
$RSign=$ReturnData["signature"];//存储返回签名做后续验签使用。
$RSignArray = Tools::array_remove($ReturnData, "signature");//需要删除签名字段

$RSignVStr =Tools::SortAndOutString($RSignArray);
Log::EchoFormat("返回SHA-1摘要字串：".urldecode($RSignVStr));

$RSignature = SHA1Util::Sha1AndHex(urldecode($RSignVStr));//签名(注意此处urldecode方法主要是去除send_time中间的空格和符号的自动自urlencode)
Log::EchoFormat("返回SHA-1摘要结果：".$RSignature);

if(SignatureUtils::VerifySign($RSignature,$GLOBALS["CER_FILE_PATH"],$RSign)){
    Log::EchoFormat("验签:Yes");//验签成功
}  else {
    throw new Exception("验签失败！");
}

if(!array_key_exists("resp_code",$RSignArray)){
    throw new Exception("缺少resp_code参数！");
}

if($RSignArray["resp_code"] == "S"){
    if(!array_key_exists("dgtl_envlp",$RSignArray)){
        throw new Exception("缺少dgtl_envlp参数！");
    }
    Log::EchoFormat("dgtl_envlp:".$RSignArray["dgtl_envlp"]);
    $RDgtlEnvlp = RSAUtil::decryptByPFXFile($RSignArray["dgtl_envlp"], $GLOBALS["PFX_FILE_PATH"],$GLOBALS["KEY_PWD"]);
    Log::EchoFormat("返回数字信封：".$RDgtlEnvlp);
    $RAesKey=  Tools::getAesKey($RDgtlEnvlp);//获取返回的AESkey
    Log::EchoFormat("返回的AESkey:".$RAesKey);
    
    $UniqueCode=  base64_decode(AESUtil::AesDecrypt($RSignArray["unique_code"], $RAesKey));
    Log::EchoFormat("唯一码:".$UniqueCode);
}