<?php
/**
 * 接收异步通知
 * Company: www.baofu.com
 * @author dasheng(大圣)
 * @date 2022年08月04日
 */
require_once '../Init/init.php';

Log::LogWirte("接收参数：".http_build_query($_REQUEST));
$ReturnData = $_REQUEST;
if(!array_key_exists("signature",$ReturnData)){
    throw new Exception("缺少验签参数！");
}
$RSign=$ReturnData["signature"];//存储返回签名做后续验签使用。
$RSignArray = Tools::array_remove($ReturnData, "signature");//需要删除签名字段

$RSignVStr =Tools::SortAndOutString($RSignArray);
Log::LogWirte("返回SHA-1摘要字串：".urldecode($RSignVStr));

$RSignature = SHA1Util::Sha1AndHex(urldecode($RSignVStr));//签名(注意此处urldecode方法主要是去除send_time中间的空格和符号的自动自urlencode)
Log::LogWirte("返回SHA-1摘要结果：".$RSignature);

if(SignatureUtils::VerifySign($RSignature,$GLOBALS["CER_FILE_PATH"],$RSign)){
    Log::LogWirte("验签:Yes");//验签成功
}  else {
    throw new Exception("验签失败！");
}

if(!array_key_exists("resp_code",$RSignArray)){
    throw new Exception("缺少resp_code参数！");
}

if($RSignArray["resp_code"] == "S"){
    Log::LogWirte("支付成功！[trans_id:".$RSignArray["trans_id"]."]");
}else if($RSignArray["resp_code"] == "I"){	
    Log::LogWirte("处理中！");
}else if($RSignArray["resp_code"] =="F"){
    Log::LogWirte("失败！");
}else{
    throw new Exception("反回异常！");//异常不得做为订单状态。
}
echo "OK";//和订单状态无关，收到通知即返回OK，